<?php

/**
 * co_tipo_proceso actions.
 *
 * @package    contratacion
 * @subpackage co_tipo_proceso
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_tipo_procesoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_TIPO_PROCESO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_TIPO_PROCESO' =>
        array(
            'id_tipo_proceso' => 'id_tipo_proceso',
            'codigo' => 'codigo',
            'descripcion' => 'descripcion'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_TIPO_PROCESO' =>
        array(
            'id_tipo_proceso,a' => array('!=' => array(-1)),
            'id_tipo_proceso,b' => array('=' => array('id_tipo_proceso')),
            'codigo' => array('=' => array('codigo')),
            'descripcion,a' => array('LIKEALLPLUS' => array('descripcion', '%'))
        /* 'id_tipo_proceso' => array('=' => array('id_tipo_proceso')),                         
          'codigo' => array('=' => array('codigo')),
          'descripcion' => array('=' => array('descripcion')),
          'rownum,start' => array('>' => array('_startRow')),
          'rownum,end' => array('<=' => array('_endRow')) */
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_tipo_proceso'; //identificador de la tabla
    protected $id_names = array('id_tipo_proceso'); //llave primaria
    protected $field_names = array('codigo', 'descripcion'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_TIPO_PROCESO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_tipo_proceso'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {

                $id_tipo_proceso = $list_data_post[0]['id_tipo_proceso'];

                $id_cen_op = 16;
                $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $id_anhos = $records[0]['id_anhos'];

                $sql = <<<EOD
            INSERT INTO CO_CONSECUTIVO_EP (ID_TIPO_PROCESO,ID_CEN_OP,ID_ANHOS,CONSECUTIVO)
                VALUES($id_tipo_proceso,$id_cen_op,$id_anhos,1)
EOD;

                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            if (isset($request['descripcion'])) {
                $descripcion = $request['descripcion'];
                $request['descripcion'] = trim($descripcion);
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            if (isset($request['descripcion'])) {
                $descripcion = $request['descripcion'];
                $request['descripcion'] = trim($descripcion);
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
